package cz.cvut.felk.cs.atg.messenger.server;

import java.io.IOException;
import java.io.InputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.logging.Level;
import java.util.logging.Logger;

@SuppressWarnings("SocketOpenedButNotSafelyClosed")
public class MessengerServer {

    private static final Logger LOGGER = Logger.getLogger("MessengerServer");
    private ServerSocket socket;
    private final int port;

    public MessengerServer(int port) {
        this.port = port;
    }

    public void start() throws IOException {
        socket = new ServerSocket(port);
        LOGGER.finest("Socket opened...");
        while(!socket.isClosed()){
            LOGGER.finest("Waiting for incomming connection...");
            Socket s = socket.accept();
            LOGGER.finest("Connection accepted...");

            InputStream is = s.getInputStream();
            StringBuilder sb = new StringBuilder();
            int c;
            LOGGER.finest("Reading data...");
            while((c = is.read()) != -1){
                sb.append((char)c);
            }

            System.out.println(sb.toString());
        }
    }

    public void close() throws IOException {
        socket.close();
    }

    public static void main(String[] args) throws IOException {
        LOGGER.setLevel(Level.ALL);
        if(args.length == 0){
            LOGGER.warning("usage java MessengerServer <portNum>");
            System.exit(1);
        }
        MessengerServer messengerServer = new MessengerServer(Integer.parseInt(args[0]));
        messengerServer.start();
        messengerServer.close();
    }
}
